> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.tester.army/api-reference/tester-army-api/tests/llms.txt.
> For full documentation content, see https://docs.tester.army/api-reference/tester-army-api/tests/llms-full.txt.

# Create a test

POST https://tester.army/v1/tests
Content-Type: application/json

Create a structured test definition for a project.

Reference: https://docs.tester.army/api-reference/tester-army-api/tests/create-a-test

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: testerarmy
  version: 1.0.0
paths:
  /v1/tests:
    post:
      operationId: create-a-test
      summary: Create a test
      description: Create a structured test definition for a project.
      tags:
        - subpackage_tests
      parameters:
        - name: Authorization
          in: header
          description: API key authentication using Bearer token format
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Test created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Tests_createATest_Response_201'
        '400':
          description: Bad Request - Invalid input parameters
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateATestRequestBadRequestError'
        '401':
          description: Unauthorized - Invalid or missing API key
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateATestRequestUnauthorizedError'
        '429':
          description: Too Many Requests - Usage limit exceeded
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateATestRequestTooManyRequestsError'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateATestRequestInternalServerError'
        '504':
          description: Gateway Timeout - Test execution exceeded time limit
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateATestRequestGatewayTimeoutError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                title:
                  type: string
                description:
                  type: string
                steps:
                  type: array
                  items:
                    $ref: '#/components/schemas/TestStep'
                projectId:
                  type: string
                groupId:
                  type:
                    - string
                    - 'null'
                  format: uuid
              required:
                - title
                - steps
                - projectId
servers:
  - url: https://tester.army
components:
  schemas:
    TestStepOneOf0Type:
      type: string
      enum:
        - act
      title: TestStepOneOf0Type
    TestStep0:
      type: object
      properties:
        title:
          type: string
        type:
          $ref: '#/components/schemas/TestStepOneOf0Type'
      required:
        - title
        - type
      title: TestStep0
    TestStepOneOf1Type:
      type: string
      enum:
        - assert
      title: TestStepOneOf1Type
    TestStep1:
      type: object
      properties:
        title:
          type: string
        type:
          $ref: '#/components/schemas/TestStepOneOf1Type'
      required:
        - title
        - type
      title: TestStep1
    TestStepOneOf2Type:
      type: string
      enum:
        - login
      title: TestStepOneOf2Type
    TestStep2:
      type: object
      properties:
        title:
          type: string
        type:
          $ref: '#/components/schemas/TestStepOneOf2Type'
        credentialId:
          type: string
          format: uuid
        temporaryEmail:
          type: boolean
      required:
        - title
        - type
      title: TestStep2
    TestStepOneOf3Type:
      type: string
      enum:
        - files
      title: TestStepOneOf3Type
    TestStep3:
      type: object
      properties:
        title:
          type: string
        type:
          $ref: '#/components/schemas/TestStepOneOf3Type'
        fileIds:
          type: array
          items:
            type: string
            format: uuid
      required:
        - title
        - type
        - fileIds
      title: TestStep3
    TestStepOneOf4Type:
      type: string
      enum:
        - screenshot
      title: TestStepOneOf4Type
    TestStep4:
      type: object
      properties:
        title:
          type: string
        type:
          $ref: '#/components/schemas/TestStepOneOf4Type'
      required:
        - type
      title: TestStep4
    TestStep:
      oneOf:
        - $ref: '#/components/schemas/TestStep0'
        - $ref: '#/components/schemas/TestStep1'
        - $ref: '#/components/schemas/TestStep2'
        - $ref: '#/components/schemas/TestStep3'
        - $ref: '#/components/schemas/TestStep4'
      title: TestStep
    TestDefinition:
      type: object
      properties:
        id:
          type: string
          format: uuid
        title:
          type: string
        description:
          type:
            - string
            - 'null'
        steps:
          type: array
          items:
            $ref: '#/components/schemas/TestStep'
        projectId:
          type: string
          format: uuid
        projectUrl:
          type:
            - string
            - 'null'
          format: uri
        projectName:
          type: string
        createdAt:
          type: string
          format: date-time
        updatedAt:
          type: string
          format: date-time
      required:
        - id
        - title
        - steps
      title: TestDefinition
    Tests_createATest_Response_201:
      type: object
      properties:
        test:
          $ref: '#/components/schemas/TestDefinition'
      required:
        - test
      title: Tests_createATest_Response_201
    CreateATestRequestBadRequestError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: CreateATestRequestBadRequestError
    CreateATestRequestUnauthorizedError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: CreateATestRequestUnauthorizedError
    CreateATestRequestTooManyRequestsError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: CreateATestRequestTooManyRequestsError
    CreateATestRequestInternalServerError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: CreateATestRequestInternalServerError
    CreateATestRequestGatewayTimeoutError:
      type: object
      properties:
        error:
          type: string
          description: Error code or type
        message:
          type: string
          description: Human-readable error message
      required:
        - error
        - message
      title: CreateATestRequestGatewayTimeoutError
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: API key authentication using Bearer token format

```

## SDK Code Examples

```python
import requests

url = "https://tester.army/v1/tests"

payload = {
    "title": "string",
    "steps": [
        {
            "title": "string",
            "type": "act"
        }
    ],
    "projectId": "string"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://tester.army/v1/tests';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"title":"string","steps":[{"title":"string","type":"act"}],"projectId":"string"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://tester.army/v1/tests"

	payload := strings.NewReader("{\n  \"title\": \"string\",\n  \"steps\": [\n    {\n      \"title\": \"string\",\n      \"type\": \"act\"\n    }\n  ],\n  \"projectId\": \"string\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://tester.army/v1/tests")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"title\": \"string\",\n  \"steps\": [\n    {\n      \"title\": \"string\",\n      \"type\": \"act\"\n    }\n  ],\n  \"projectId\": \"string\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://tester.army/v1/tests")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"title\": \"string\",\n  \"steps\": [\n    {\n      \"title\": \"string\",\n      \"type\": \"act\"\n    }\n  ],\n  \"projectId\": \"string\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://tester.army/v1/tests', [
  'body' => '{
  "title": "string",
  "steps": [
    {
      "title": "string",
      "type": "act"
    }
  ],
  "projectId": "string"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://tester.army/v1/tests");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"title\": \"string\",\n  \"steps\": [\n    {\n      \"title\": \"string\",\n      \"type\": \"act\"\n    }\n  ],\n  \"projectId\": \"string\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "title": "string",
  "steps": [
    [
      "title": "string",
      "type": "act"
    ]
  ],
  "projectId": "string"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://tester.army/v1/tests")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```